/// <reference types="react" />
import * as React from 'react';
import { Poser } from 'popmotion-pose';
import { ChildRegistration, CurrentPose, PoseElementProps, PopStyle } from './PoseElement.types';
export declare const PoseParentContext: any;
export declare class PoseElement extends React.PureComponent<PoseElementProps> {
    props: PoseElementProps;
    poser: Poser;
    ref: Element;
    styleProps: {
        [key: string]: any;
    };
    children: Set<ChildRegistration>;
    restoreDisplay: string;
    popStyle?: PopStyle;
    private childrenHandlers;
    getInitialPose(): CurrentPose;
    getSetProps(): {
        [key: string]: any;
        withParent?: boolean;
    };
    setRef: (ref: Element) => void;
    componentDidMount(): void;
    componentWillUpdate({pose, resize}: PoseElementProps): void;
    componentDidUpdate(prevProps: PoseElementProps): void;
    componentWillUnmount(): void;
    initPoser(poser: Poser): void;
    setPose(pose: CurrentPose): void;
    flushChildren(): void;
    render(): JSX.Element;
}
