import { Poser, PoserProps } from 'popmotion-pose';
export declare type ChildRegistration = {
    element: Element;
    poserProps: PoserProps;
    onRegistered: (poser: Poser) => void;
};
export declare type CurrentPose = string | string[];
export declare type PoseContextProps = {
    registerChild?: (props: ChildRegistration) => void;
    onUnmount?: (child: Poser) => any;
    getPoseFromParent?: () => CurrentPose;
    getParentPoseProps?: () => PoserProps;
};
export declare type PoseElementProps = {
    children?: any;
    elementType: string;
    poseProps: PoserProps;
    pose?: CurrentPose;
    initialPose?: CurrentPose;
    withParent?: boolean;
    onChange?: {
        [key: string]: (v: any) => any;
    };
    innerRef?: (el: Element) => any;
    [key: string]: any;
} & PoseContextProps;
export declare type PopStyle = {
    position: 'absolute';
    top: number;
    left: number;
    width: number;
    height: number;
};
